/*
 * Copyright (C) 2017 favdb
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package storybook.model.hbn.dao;

import storybook.model.book.Book;
import storybook.ui.MainFrame;

/**
 *
 * @author favdb
 */
public class DAOutil {

	public static final String KEY = "key",
			NAME = "name",
			NUMBER = "number",
			ATTRIBUTE = "attribute",
			CATEGORY = "category",
			EPISODE = "episode",
			GENDER = "gender",
			PART = "part",
			PERSON = "person",
			FIRSTNAME = "firstname",
			LASTNAME = "lastname",
			CHAPTER = "chapter",
			CHAPTERNO = "chapterno",
			ITEM = "item",
			LOCATION = "location",
			PLOT = "plot",
			SCENE = "scene",
			SCENENO = "sceneno",
			SCENESTART = "startScene",
			SCENEEND = "endScene",
			SORT = "sort",
			STATUS = "status",
			STRAND = "strand",
			TAG = "tag";

	private DAOutil() {
		throw new IllegalStateException("Utility class");
	}

	public static SbGenericDAOImpl getDAO(MainFrame m, Book.TYPE type) {
		switch (type) {
			case ATTRIBUTE:
				return (new AttributeDAOImpl(m.getSession()));
			case CATEGORY:
				return (new CategoryDAOImpl(m.getSession()));
			case CHAPTER:
				return (new ChapterDAOImpl(m.getSession()));
			case ENDNOTE:
				return (new EndnoteDAOImpl(m.getSession()));
			case EPISODE:
				return (new EpisodeDAOImpl(m.getSession()));
			case EVENT:
				return (new EventDAOImpl(m.getSession()));
			case GENDER:
				return (new GenderDAOImpl(m.getSession()));
			case IDEA:
				return (new IdeaDAOImpl(m.getSession()));
			case INTERNAL:
				return (new InternalDAOImpl(m.getSession()));
			case ITEM:
				return (new ItemDAOImpl(m.getSession()));
			case ITEMLINK:
				return (new ItemlinkDAOImpl(m.getSession()));
			case LOCATION:
				return (new LocationDAOImpl(m.getSession()));
			case MEMO:
				return (new MemoDAOImpl(m.getSession()));
			case PART:
				return (new PartDAOImpl(m.getSession()));
			case PERSON:
				return (new PersonDAOImpl(m.getSession()));
			case PLOT:
				return (new PlotDAOImpl(m.getSession()));
			case RELATION:
				return (new RelationDAOImpl(m.getSession()));
			case SCENE:
				return (new SceneDAOImpl(m.getSession()));
			case STRAND:
				return (new StrandDAOImpl(m.getSession()));
			case TAG:
				return (new TagDAOImpl(m.getSession()));
			case TAGLINK:
			default:
				return (new TaglinkDAOImpl(m.getSession()));
		}
	}

	public static AttributeDAOImpl getAttributeDAO(MainFrame m) {
		return (new AttributeDAOImpl(m.getSession()));
	}

	public static CategoryDAOImpl getCategoryDAO(MainFrame m) {
		return (new CategoryDAOImpl(m.getSession()));
	}

	public static ChapterDAOImpl getChapterDAO(MainFrame m) {
		return (new ChapterDAOImpl(m.getSession()));
	}

	public static EndnoteDAOImpl getEndnoteDAO(MainFrame m) {
		return (new EndnoteDAOImpl(m.getSession()));
	}

	public static EpisodeDAOImpl getEpisodeDAO(MainFrame m) {
		return (new EpisodeDAOImpl(m.getSession()));
	}

	public static EventDAOImpl getEventDAO(MainFrame m) {
		return (new EventDAOImpl(m.getSession()));
	}

	public static GenderDAOImpl getGenderDAO(MainFrame m) {
		return (new GenderDAOImpl(m.getSession()));
	}

	public static IdeaDAOImpl getIdeaDAO(MainFrame m) {
		return (new IdeaDAOImpl(m.getSession()));
	}

	public static InternalDAOImpl getInternalDAO(MainFrame m) {
		return (new InternalDAOImpl(m.getSession()));
	}

	public static ItemDAOImpl getItemDAO(MainFrame m) {
		return (new ItemDAOImpl(m.getSession()));
	}

	public static ItemlinkDAOImpl getItemlinkDAO(MainFrame m) {
		return (new ItemlinkDAOImpl(m.getSession()));
	}

	public static LocationDAOImpl getLocationDAO(MainFrame m) {
		return (new LocationDAOImpl(m.getSession()));
	}

	public static MemoDAOImpl getMemoDAO(MainFrame m) {
		return (new MemoDAOImpl(m.getSession()));
	}

	public static PartDAOImpl getPartDAO(MainFrame m) {
		return (new PartDAOImpl(m.getSession()));
	}

	public static PersonDAOImpl getPersonDAO(MainFrame m) {
		return (new PersonDAOImpl(m.getSession()));
	}

	public static PlotDAOImpl getPlotDAO(MainFrame m) {
		return (new PlotDAOImpl(m.getSession()));
	}

	public static RelationDAOImpl getRelationDAO(MainFrame m) {
		return (new RelationDAOImpl(m.getSession()));
	}

	public static SceneDAOImpl getSceneDAO(MainFrame m) {
		return (new SceneDAOImpl(m.getSession()));
	}

	public static StrandDAOImpl getStrandDAO(MainFrame m) {
		return (new StrandDAOImpl(m.getSession()));
	}

	public static TagDAOImpl getTagDAO(MainFrame m) {
		return (new TagDAOImpl(m.getSession()));
	}

	public static TaglinkDAOImpl getTaglinkDAO(MainFrame m) {
		return (new TaglinkDAOImpl(m.getSession()));
	}

}
